unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, jpeg, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    edAppUserName: TEdit;
    Label2: TLabel;
    edSerial: TEdit;
    btnCancel: TButton;
    btnCheckSerial: TButton;
    Label3: TLabel;
    Image1: TImage;
    procedure btnCancelClick(Sender: TObject);
    procedure btnCheckSerialClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    function CalcCheckSum(Addr: Pointer; Size: Integer): DWORD;
    procedure CheckCodeProtect;
    function GenerateSerial(const AppUserName: string): string;
    procedure CheckIsDebugerPresent;
    procedure BlockDebugActiveProcess;
  end;

  procedure CheckedCodeEnd;

var
  Form1: TForm1;

implementation

uses
  TlHelp32;

const
  CheckedCodeValidCheckSum: DWORD = 337148;

{$R *.dfm}

procedure CheckedCodeBegin;
begin
end;

procedure TForm1.btnCancelClick(Sender: TObject);
begin
  OutputDebugString('btnCancelClick');
  Close;
end;

function TForm1.CalcCheckSum(Addr: Pointer; Size: Integer): DWORD;
var
  pRealData, pCursor: PByte;
  I: Integer;
  Dumee: DWORD;
begin
  pRealData := GetMemory(Size);
  try
    ReadProcessMemory(GetCurrentProcess, Addr, pRealData, Size, Dumee);
    Result := 0;
    pCursor := pRealData;
    for I := 0 to Size - 1 do
    begin
      if pCursor^ <> 0 then
        Inc(Result, pCursor^)
      else
        Dec(Result);
      Inc(pCursor);
    end;
  finally
    FreeMemory(pRealData);
  end;
end;

procedure TForm1.CheckCodeProtect;
var
  CheckedCodeBeginAddr, CheckedCodeEndAddr: Pointer;
  CurrentCheckSum: DWORD;
begin
  //    

  OutputDebugString('CheckCodeProtect');

  //     
  CheckedCodeBeginAddr := @CheckedCodeBegin;

  //     
  CheckedCodeEndAddr := @CheckedCodeEnd;

  //       

  CurrentCheckSum := CalcCheckSum(CheckedCodeBeginAddr,
    Integer(CheckedCodeEndAddr) - Integer(CheckedCodeBeginAddr));

  OutputDebugString(PChar('Code checksum: ' + IntToStr(CurrentCheckSum)));

  if CurrentCheckSum <> CheckedCodeValidCheckSum then
  begin
    MessageBox(Handle, '   .',
      PChar(Application.Title), MB_ICONERROR);
    TerminateProcess(GetCurrentProcess, 0);
  end;
end;

function TForm1.GenerateSerial(const AppUserName: string): string;
const
  MagicSerialMask: int64 = $C5315E6121543992;
var
  I: Integer;
  SN: int64;
  RawSN: string;
begin
  OutputDebugString('GenerateSerial');
  SN := 0;
  Result := '';
  for I := 1 to Length(AppUserName) do
  begin
    Inc(SN, Word(AppUserName[I]));
    SN := SN * 123456;
  end;
  Sn := SN xor MagicSerialMask;
  RawSN := IntToHex(SN, 16);
  for I := 1 to 16 do
    if ((I - 1) mod 4 = 0) and (I > 1) then
      Result := Result + '-' + RawSN[I]
    else
      Result := Result + RawSN[I];
  OutputDebugString(PChar('SN for "' + AppUserName + '" = ' + Result));
end;

procedure TForm1.btnCheckSerialClick(Sender: TObject);
begin
  OutputDebugString('btnCheckSerialClick');

  //   
  CheckCodeProtect;

  if edAppUserName.Text = '' then
  begin
    ShowMessage('  ');
    Exit;
  end;
  if edSerial.Text = '' then
  begin
    ShowMessage('  ');
    Exit;
  end;
  if Length(edSerial.Text) <> 19 then
  begin
    ShowMessage('  ');
    Exit;
  end;
  if edSerial.Text <> GenerateSerial(edAppUserName.Text) then
    Application.MessageBox('  ',
      PChar(Application.Title), MB_OK or MB_ICONERROR)
  else
  begin
    Image1.Visible := True;
    Label1.Visible := False;
    Label2.Visible := False;
    Label3.Visible := False;
    edAppUserName.Visible := False;
    edSerial.Visible := False;
    btnCancel.Visible := False;
    btnCheckSerial.Visible := False;
  end;
end;

  function IsDebuggerPresent: BOOL; stdcall; external kernel32;

procedure TForm1.CheckIsDebugerPresent;
var
  Snapshot: THandle;
  ProcessEntry: TProcessEntry32;
  ProcessHandle: THandle;
  pIsDebuggerPresent: PDWORD;
  OriginalBytes: DWORD;
  lpNumberOfBytesRead: DWORD;
begin
  pIsDebuggerPresent :=
    GetProcAddress(GetModuleHandle(kernel32), 'IsDebuggerPresent');
  Snapshot := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  if Snapshot <> INVALID_HANDLE_VALUE then
  try
    ProcessEntry.dwSize := SizeOf(TProcessEntry32);
    if Process32First(Snapshot, ProcessEntry) then
    begin
      repeat
        if ProcessEntry.th32ProcessID = GetCurrentProcessId then Continue;
        ProcessHandle := OpenProcess(PROCESS_ALL_ACCESS, False,
          ProcessEntry.th32ProcessID);
        if ProcessHandle <> 0 then
        try
          if ReadProcessMemory(ProcessHandle, pIsDebuggerPresent,
            @OriginalBytes, 4, lpNumberOfBytesRead) then
          begin
            if OriginalBytes <> pIsDebuggerPresent^ then
            begin
              MessageBox(Handle, ' IsDebuggerPresent .',
                PChar(Application.Title), MB_ICONERROR);
              TerminateProcess(GetCurrentProcess, 0);
            end;
            if IsDebuggerPresent then
            begin
              MessageBox(Handle, '    .',
                PChar(Application.Title), MB_ICONERROR);
              TerminateProcess(GetCurrentProcess, 0);
            end;
          end;
        finally
          CloseHandle(ProcessHandle);
        end;
      until not Process32Next(Snapshot, ProcessEntry)
    end;
  finally
    CloseHandle(Snapshot);
  end;
end;

type
  TDbgUiRemoteBreakinPath = packed record
    push0: Word;
    push: Byte;
    CurrProc: DWORD;
    moveax: byte;
    TerminateProcAddr: DWORD;
    calleax: Word;
  end;

procedure TForm1.BlockDebugActiveProcess;
var
  pDbgUiRemoteBreakin: Pointer;
  Path: TDbgUiRemoteBreakinPath;
  OldProtect: DWORD;
begin
  pDbgUiRemoteBreakin :=
    GetProcAddress(GetModuleHandle('ntdll.dll'), 'DbgUiRemoteBreakin');
  if pDbgUiRemoteBreakin = nil then Exit;
  Path.push0 := $006A;
  Path.push := $68;
  Path.CurrProc := $FFFFFFFF;
  Path.moveax := $B8;
  Path.TerminateProcAddr :=
    DWORD(GetProcAddress(GetModuleHandle(kernel32), 'TerminateProcess'));
  Path.calleax := $D0FF;
  if VirtualProtect(pDbgUiRemoteBreakin, SizeOf(TDbgUiRemoteBreakinPath),
    PAGE_READWRITE, OldProtect) then
  try
    Move(Path, pDbgUiRemoteBreakin^, SizeOf(TDbgUiRemoteBreakinPath));
  finally
    VirtualProtect(pDbgUiRemoteBreakin, SizeOf(TDbgUiRemoteBreakinPath),
      OldProtect, OldProtect);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BlockDebugActiveProcess;
  CheckCodeProtect;
  CheckIsDebugerPresent; 
end;

procedure CheckedCodeEnd;
begin
end;

end.
